'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _OutputLayer2 = require('./OutputLayer');

var _OutputLayer3 = _interopRequireDefault(_OutputLayer2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HiddenLayer = function (_OutputLayer) {
    _inherits(HiddenLayer, _OutputLayer);

    function HiddenLayer() {
        _classCallCheck(this, HiddenLayer);

        return _possibleConstructorReturn(this, (HiddenLayer.__proto__ || Object.getPrototypeOf(HiddenLayer)).apply(this, arguments));
    }

    _createClass(HiddenLayer, [{
        key: 'setOutputLayer',
        value: function setOutputLayer(outputLayer) {
            this.outputLayer = outputLayer;
        }
    }, {
        key: 'backPropagateCalculateErrorGradient',
        value: function backPropagateCalculateErrorGradient() {
            //Defining these locally speeds up the loop below by reducing object property access
            var nodeCount = this.nodeCount;
            var errorGradients = this.errorGradients;
            var outputs = this.outputs;
            var activationFunctionDerivative = this.activationFunctionDerivative;
            var outputLayerNodeCount = this.outputLayer.nodeCount;
            var outputLayerWeights = this.outputLayer.weights;
            var outputLayerInputNodeCount = this.outputLayer.inputNodeCount;
            var outputLayerErrorGradients = this.outputLayer.errorGradients;
            var inputs = this.inputs;
            var inputCount = this.inputCount;
            var inputNodeCount = this.inputNodeCount;

            for (var neuronI = 0; neuronI < nodeCount; neuronI++) {
                var errorWithRespectToOutput = 0;
                for (var outputI = 0; outputI < outputLayerNodeCount; outputI++) {
                    errorWithRespectToOutput += outputLayerErrorGradients[outputI] * outputLayerWeights[outputI * outputLayerInputNodeCount + neuronI];
                }

                var activationErrorGradient = errorWithRespectToOutput * activationFunctionDerivative(outputs[neuronI]);
                errorGradients[neuronI] = activationErrorGradient;

                for (var inputI = 0; inputI < inputCount; inputI++) {
                    this.weightErrorGradients[neuronI * inputNodeCount + inputI] = inputs[inputI] * activationErrorGradient;
                }
                this.weightErrorGradients[neuronI * inputNodeCount + inputI] = activationErrorGradient; //Bias node
            }
        }
    }]);

    return HiddenLayer;
}(_OutputLayer3.default);

exports.default = HiddenLayer;